_cherryrgb_ncli() {
    local i cur prev opts cmd
    COMPREPLY=()
    cur="${COMP_WORDS[COMP_CWORD]}"
    prev="${COMP_WORDS[COMP_CWORD-1]}"
    cmd=""
    opts=""

    for i in ${COMP_WORDS[@]}
    do
        case "${cmd},${i}" in
            ",$1")
                cmd="cherryrgb_ncli"
                ;;
            cherryrgb_ncli,animation)
                cmd="cherryrgb_ncli__animation"
                ;;
            cherryrgb_ncli,color-profile-file)
                cmd="cherryrgb_ncli__color__profile__file"
                ;;
            cherryrgb_ncli,custom-colors)
                cmd="cherryrgb_ncli__custom__colors"
                ;;
            cherryrgb_ncli,help)
                cmd="cherryrgb_ncli__help"
                ;;
            cherryrgb_ncli__help,animation)
                cmd="cherryrgb_ncli__help__animation"
                ;;
            cherryrgb_ncli__help,color-profile-file)
                cmd="cherryrgb_ncli__help__color__profile__file"
                ;;
            cherryrgb_ncli__help,custom-colors)
                cmd="cherryrgb_ncli__help__custom__colors"
                ;;
            cherryrgb_ncli__help,help)
                cmd="cherryrgb_ncli__help__help"
                ;;
            *)
                ;;
        esac
    done

    case "${cmd}" in
        cherryrgb_ncli)
            opts="-d -s -b -h -V --debug --socket --brightness --help --version animation custom-colors color-profile-file help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 1 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                --socket)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                -s)
                    COMPREPLY=($(compgen -f "${cur}"))
                    return 0
                    ;;
                --brightness)
                    COMPREPLY=($(compgen -W "off low medium high full" -- "${cur}"))
                    return 0
                    ;;
                -b)
                    COMPREPLY=($(compgen -W "off low medium high full" -- "${cur}"))
                    return 0
                    ;;
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        cherryrgb_ncli__animation)
            opts="-r -h --rainbow --help wave spectrum breathing static radar vortex fire stars rain rolling curve wave_mid scan radiation ripples single_key very_fast fast medium slow very_slow [COLOR]"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        cherryrgb_ncli__color__profile__file)
            opts="-k -h --keep-existing-colors --help <FILE_PATH>"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        cherryrgb_ncli__custom__colors)
            opts="-h --help [COLORS]..."
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        cherryrgb_ncli__help)
            opts="animation custom-colors color-profile-file help"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 2 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        cherryrgb_ncli__help__animation)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        cherryrgb_ncli__help__color__profile__file)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        cherryrgb_ncli__help__custom__colors)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
        cherryrgb_ncli__help__help)
            opts=""
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 3 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
    esac
}

complete -F _cherryrgb_ncli -o bashdefault -o default cherryrgb_ncli
